<script setup lang="ts">
import type { TreeOption } from 'naive-ui'
import { TESLDataInstance } from 'api/TESLData'
import { NButton, useMessage } from 'naive-ui'
import type { INamespace } from 'types/tags'

const props = defineProps({
  modelValue: {
    type: Boolean,
    default: false,
  },
})
const emit = defineEmits(['update:modelValue'])
const message = useMessage()

// State
const selectedNamespace = ref('')
const copyNamespace = ref('')
const labelNamespace = ref('')
const selectedPropertyData = computed(() => {
  return TESLDataInstance.getPropertiesByNamespace(selectedNamespace.value)
})

const showModal = computed({
  get() {
    return props.modelValue
  },
  set(value) {
    emit('update:modelValue', value)
    if (value === false) {
      // unset the state
      selectedNamespace.value = ''
      copyNamespace.value = ''
      labelNamespace.value = ''
    }
  },
})

const createData = (data: INamespace[], baseKey = ''): TreeOption[] | undefined => {
  if (!data)
    return undefined
  return data.map((item) => {
    const key = baseKey && baseKey.length ? baseKey + '_' + item.name : item.name
    return {
      label: item.label,
      key,
      children: item.subnamespaces ? createData(item.subnamespaces, key) : undefined,
    }
  })
}

const selectChange = (key: Array<string | number>, option: Array<TreeOption | null>) => {
  const clickedOption = option[0]
  const clickedNamespace = key.toString()
  const formattedNamespace = clickedNamespace.indexOf('_') > 0 ? clickedNamespace.slice(clickedNamespace.indexOf('_') + 1, clickedNamespace.length) : clickedNamespace

  selectedNamespace.value = formattedNamespace
  copyNamespace.value = clickedNamespace.replace('_', '.')
  labelNamespace.value = clickedOption && clickedOption.label ? clickedOption.label : ''
}

const data: TreeOption[] = createData(TESLDataInstance.unflattenedNamespaceData) || []
</script>

<template>
  <n-modal :show="showModal" @mask-click="showModal = false">
    <n-card
      :style="{ 'width': '70%', 'max-height': '100vh', 'min-height': '70vh' }"
      :bordered="false"
      size="huge"
      role="dialog"
      aria-modal="true"
      :header-style="{ 'padding-top': 0, 'padding-bottom': 0 }"
      :content-style="{ 'padding': 0, 'border-top': '1px solid rgb(239, 239, 245)' }"
      :footer-style="{ padding: 0 }"
    >
      <template #header>
        <n-divider title-placement="center">
          Data Tag Reference
        </n-divider>
      </template>
      <n-layout has-sider>
        <n-layout-sider
          bordered
          :width="240"
        >
          <n-tree
            block-line
            :data="data"
            :on-update:selected-keys="selectChange"
            style="--n-font-size:16px;"
          />
        </n-layout-sider>
        <n-layout>
          <reference-properties v-model="selectedPropertyData" :copy-namespace="copyNamespace" :label-namespace="labelNamespace" />
        </n-layout>
      </n-layout>
      <template #footer>
        <more-info header="Need more info on Dynamic Data?" padding>
          Check out the TE Knowledge Base on using Dynamic Data in your Email Templates
        </more-info>
      </template>
    </n-card>
  </n-modal>
</template>
